diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-phpmailer.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-phpmailer.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/class-phpmailer.php	2012-06-25 22:54:17.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/class-phpmailer.php	2013-02-28 12:33:13.000000000 -0600
***************
*** 1901,1929 ****
     * @return string
     */
    public function EncodeQ($str, $position = 'text') {
!     // There should not be any EOL in the string
!     $encoded = preg_replace('/[\r\n]*/', '', $str);
! 
      switch (strtolower($position)) {
        case 'phrase':
!         $encoded = preg_replace("/([^A-Za-z0-9!*+\/ -])/e", "'='.sprintf('%02X', ord('\\1'))", $encoded);
          break;
        case 'comment':
!         $encoded = preg_replace("/([\(\)\"])/e", "'='.sprintf('%02X', ord('\\1'))", $encoded);
        case 'text':
        default:
!         // Replace every high ascii, control =, ? and _ characters
!         //TODO using /e (equivalent to eval()) is probably not a good idea
!         $encoded = preg_replace('/([\000-\011\013\014\016-\037\075\077\137\177-\377])/e',
!                                 "'='.sprintf('%02X', ord(stripslashes('\\1')))", $encoded);
          break;
      }
  
-     // Replace every spaces to _ (more readable than =20)
-     $encoded = str_replace(' ', '_', $encoded);
- 
-     return $encoded;
-   }
  
    /**
     * Adds a string or binary attachment (non-filesystem) to the list.
--- 2124,2160 ----
     * @return string
     */
    public function EncodeQ($str, $position = 'text') {
!     //There should not be any EOL in the string
! 	$pattern="";
!     $encoded = str_replace(array("\r", "\n"), '', $str);
      switch (strtolower($position)) {
        case 'phrase':
!         $pattern = '^A-Za-z0-9!*+\/ -';
          break;
+ 
        case 'comment':
!         $pattern = '\(\)"';
!         //note that we dont break here!
!         //for this reason we build the $pattern withoud including delimiters and []
! 
        case 'text':
        default:
!         //Replace every high ascii, control =, ? and _ characters
!         //We put \075 (=) as first value to make sure it's the first one in being converted, preventing double encode
!         $pattern = '\075\000-\011\013\014\016-\037\077\137\177-\377' . $pattern;
          break;
      }
+     
+     if (preg_match_all("/[{$pattern}]/", $encoded, $matches)) {
+       foreach (array_unique($matches[0]) as $char) {
+         $encoded = str_replace($char, '=' . sprintf('%02X', ord($char)), $encoded);
+       }
+     }
+     
+     //Replace every spaces to _ (more readable than =20)
+     return str_replace(' ', '_', $encoded);
+ }
  
  
    /**
     * Adds a string or binary attachment (non-filesystem) to the list.
***************
*** 1989,2000 ****
      return true;
    }
  
!   public function AddStringEmbeddedImage($string, $cid, $filename = '', $encoding = 'base64', $type = 'application/octet-stream') {
      // Append to $attachment array
      $this->attachment[] = array(
        0 => $string,
!       1 => $filename,
!       2 => basename($filename),
        3 => $encoding,
        4 => $type,
        5 => true,  // isStringAttachment
--- 2220,2244 ----
      return true;
    }
  
!   /**
!    * Adds an embedded stringified attachment.  This can include images, sounds, and
!    * just about any other document.  Make sure to set the $type to an
!    * image type.  For JPEG images use "image/jpeg" and for GIF images
!    * use "image/gif".
!    * @param string $string The attachment.
!    * @param string $cid Content ID of the attachment.  Use this to identify
!    *        the Id for accessing the image in an HTML form.
!    * @param string $name Overrides the attachment name.
!    * @param string $encoding File encoding (see $Encoding).
!    * @param string $type File extension (MIME) type.
!    * @return bool
!    */
!   public function AddStringEmbeddedImage($string, $cid, $name = '', $encoding = 'base64', $type = 'application/octet-stream') {
      // Append to $attachment array
      $this->attachment[] = array(
        0 => $string,
!       1 => $name,
!       2 => $name,
        3 => $encoding,
        4 => $type,
        5 => true,  // isStringAttachment
***************
*** 2017,2022 ****
--- 2261,2270 ----
      return false;
    }
  
+   /**
+    * Returns true if an attachment (non-inline) is present.
+    * @return bool
+    */
    public function AttachmentExists() {
      foreach($this->attachment as $attachment) {
        if ($attachment[6] == 'attachment') {
***************
*** 2026,2033 ****
      return false;
    }
  
    public function AlternativeExists() {
!     return strlen($this->AltBody)>0;
    }
  
    /////////////////////////////////////////////////
--- 2274,2285 ----
      return false;
    }
  
+   /**
+    * Does this message have an alternative body set?
+    * @return bool
+    */
    public function AlternativeExists() {
!     return !empty($this->AltBody);
    }
  
    /////////////////////////////////////////////////
***************
*** 2111,2116 ****
--- 2363,2369 ----
    /**
     * Adds the error message to the error container.
     * @access protected
+    * @param string $msg
     * @return void
     */
    protected function SetError($msg) {
***************
*** 2160,2165 ****
--- 2413,2419 ----
    /**
     * Returns a message in the appropriate language.
     * @access protected
+    * @param string $key
     * @return string
     */
    protected function Lang($key) {
***************
*** 2184,2213 ****
    }
  
    /**
!    * Changes every end of line from CR or LF to CRLF.
     * @access public
     * @return string
     */
    public function FixEOL($str) {
!     $str = str_replace("\r\n", "\n", $str);
!     $str = str_replace("\r", "\n", $str);
!     $str = str_replace("\n", $this->LE, $str);
!     return $str;
    }
  
    /**
!    * Adds a custom header.
     * @access public
     * @return void
     */
!   public function AddCustomHeader($custom_header) {
!     $this->CustomHeader[] = explode(':', $custom_header, 2);
    }
  
    /**
     * Evaluates the message and returns modifications for inline images and backgrounds
     * @access public
!    * @return $message
     */
    public function MsgHTML($message, $basedir = '') {
      preg_match_all("/(src|background)=[\"'](.*)[\"']/Ui", $message, $images);
--- 2438,2481 ----
    }
  
    /**
!    * Changes every end of line from CRLF, CR or LF to $this->LE.
     * @access public
+    * @param string $str String to FixEOL
     * @return string
     */
    public function FixEOL($str) {
! 	// condense down to \n
! 	$nstr = str_replace(array("\r\n", "\r"), "\n", $str);
! 	// Now convert LE as needed
! 	if ($this->LE !== "\n") {
! 		$nstr = str_replace("\n", $this->LE, $nstr);
! 	}
!     return  $nstr;
    }
  
    /**
!    * Adds a custom header. $name value can be overloaded to contain
!    * both header name and value (name:value)
     * @access public
+    * @param string $name custom header name
+    * @param string $value header value
     * @return void
     */
!   public function AddCustomHeader($name, $value=null) {
! 	if ($value === null) {
! 		// Value passed in as name:value
! 		$this->CustomHeader[] = explode(':', $name, 2);
! 	} else {
! 		$this->CustomHeader[] = array($name, $value);
! 	}
    }
  
    /**
     * Evaluates the message and returns modifications for inline images and backgrounds
     * @access public
!    * @param string $message Text to be HTML modified
!    * @param string $basedir baseline directory for path
!    * @return string $message
     */
    public function MsgHTML($message, $basedir = '') {
      preg_match_all("/(src|background)=[\"'](.*)[\"']/Ui", $message, $images);
***************
*** 2217,2229 ****
          if (!preg_match('#^[A-z]+://#', $url)) {
            $filename = basename($url);
            $directory = dirname($url);
!           ($directory == '.') ? $directory='': '';
!           $cid = 'cid:' . md5($filename);
            $ext = pathinfo($filename, PATHINFO_EXTENSION);
            $mimeType  = self::_mime_types($ext);
            if ( strlen($basedir) > 1 && substr($basedir, -1) != '/') { $basedir .= '/'; }
            if ( strlen($directory) > 1 && substr($directory, -1) != '/') { $directory .= '/'; }
!           if ( $this->AddEmbeddedImage($basedir.$directory.$filename, md5($filename), $filename, 'base64', $mimeType) ) {
              $message = preg_replace("/".$images[1][$i]."=[\"']".preg_quote($url, '/')."[\"']/Ui", $images[1][$i]."=\"".$cid."\"", $message);
            }
          }
--- 2485,2499 ----
          if (!preg_match('#^[A-z]+://#', $url)) {
            $filename = basename($url);
            $directory = dirname($url);
!           if ($directory == '.') {
!             $directory = '';
!           }
!           $cid = 'cid:' . md5($url);
            $ext = pathinfo($filename, PATHINFO_EXTENSION);
            $mimeType  = self::_mime_types($ext);
            if ( strlen($basedir) > 1 && substr($basedir, -1) != '/') { $basedir .= '/'; }
            if ( strlen($directory) > 1 && substr($directory, -1) != '/') { $directory .= '/'; }
!           if ( $this->AddEmbeddedImage($basedir.$directory.$filename, md5($url), $filename, 'base64', $mimeType) ) {
              $message = preg_replace("/".$images[1][$i]."=[\"']".preg_quote($url, '/')."[\"']/Ui", $images[1][$i]."=\"".$cid."\"", $message);
            }
          }
***************
*** 2231,2270 ****
      }
      $this->IsHTML(true);
      $this->Body = $message;
! 	if (empty($this->AltBody)) {
! 		$textMsg = trim(strip_tags(preg_replace('/<(head|title|style|script)[^>]*>.*?<\/\\1>/s', '', $message)));
! 		if (!empty($textMsg)) {
! 			$this->AltBody = html_entity_decode($textMsg, ENT_QUOTES, $this->CharSet);
! 		}
! 	}
      if (empty($this->AltBody)) {
        $this->AltBody = 'To view this email message, open it in a program that understands HTML!' . "\n\n";
      }
! 	return $message;
    }
  
    /**
     * Gets the MIME type of the embedded or inline image
!    * @param string File extension
     * @access public
     * @return string MIME type of ext
     * @static
     */
    public static function _mime_types($ext = '') {
      $mimes = array(
        'hqx'   =>  'application/mac-binhex40',
        'cpt'   =>  'application/mac-compactpro',
-       'doc'   =>  'application/msword',
        'bin'   =>  'application/macbinary',
        'dms'   =>  'application/octet-stream',
        'lha'   =>  'application/octet-stream',
        'lzh'   =>  'application/octet-stream',
-       'exe'   =>  'application/octet-stream',
-       'class' =>  'application/octet-stream',
        'psd'   =>  'application/octet-stream',
-       'so'    =>  'application/octet-stream',
        'sea'   =>  'application/octet-stream',
!       'dll'   =>  'application/octet-stream',
        'oda'   =>  'application/oda',
        'pdf'   =>  'application/pdf',
        'ai'    =>  'application/postscript',
--- 2501,2542 ----
      }
      $this->IsHTML(true);
      $this->Body = $message;
!     if (empty($this->AltBody)) {
!         $textMsg = trim(strip_tags(preg_replace('/<(head|title|style|script)[^>]*>.*?<\/\\1>/s', '', $message)));
!         if (!empty($textMsg)) {
!             $this->AltBody = html_entity_decode($textMsg, ENT_QUOTES, $this->CharSet);
!         }
!     }
      if (empty($this->AltBody)) {
        $this->AltBody = 'To view this email message, open it in a program that understands HTML!' . "\n\n";
      }
!     return $message;
    }
  
    /**
     * Gets the MIME type of the embedded or inline image
!    * @param string $ext File extension
     * @access public
     * @return string MIME type of ext
     * @static
     */
    public static function _mime_types($ext = '') {
      $mimes = array(
+       'xl'    =>  'application/excel',
        'hqx'   =>  'application/mac-binhex40',
        'cpt'   =>  'application/mac-compactpro',
        'bin'   =>  'application/macbinary',
+       'doc'   =>  'application/msword',
+       'word'  =>  'application/msword',
+       'class' =>  'application/octet-stream',
+       'dll'   =>  'application/octet-stream',
        'dms'   =>  'application/octet-stream',
+       'exe'   =>  'application/octet-stream',
        'lha'   =>  'application/octet-stream',
        'lzh'   =>  'application/octet-stream',
        'psd'   =>  'application/octet-stream',
        'sea'   =>  'application/octet-stream',
!       'so'    =>  'application/octet-stream',
        'oda'   =>  'application/oda',
        'pdf'   =>  'application/pdf',
        'ai'    =>  'application/postscript',
***************
*** 2282,2290 ****
        'dxr'   =>  'application/x-director',
        'dvi'   =>  'application/x-dvi',
        'gtar'  =>  'application/x-gtar',
-       'php'   =>  'application/x-httpd-php',
-       'php4'  =>  'application/x-httpd-php',
        'php3'  =>  'application/x-httpd-php',
        'phtml' =>  'application/x-httpd-php',
        'phps'  =>  'application/x-httpd-php-source',
        'js'    =>  'application/x-javascript',
--- 2554,2562 ----
        'dxr'   =>  'application/x-director',
        'dvi'   =>  'application/x-dvi',
        'gtar'  =>  'application/x-gtar',
        'php3'  =>  'application/x-httpd-php',
+       'php4'  =>  'application/x-httpd-php',
+       'php'   =>  'application/x-httpd-php',
        'phtml' =>  'application/x-httpd-php',
        'phps'  =>  'application/x-httpd-php-source',
        'js'    =>  'application/x-javascript',
***************
*** 2292,2344 ****
        'sit'   =>  'application/x-stuffit',
        'tar'   =>  'application/x-tar',
        'tgz'   =>  'application/x-tar',
-       'xhtml' =>  'application/xhtml+xml',
        'xht'   =>  'application/xhtml+xml',
        'zip'   =>  'application/zip',
        'mid'   =>  'audio/midi',
        'midi'  =>  'audio/midi',
-       'mpga'  =>  'audio/mpeg',
        'mp2'   =>  'audio/mpeg',
        'mp3'   =>  'audio/mpeg',
        'aif'   =>  'audio/x-aiff',
-       'aiff'  =>  'audio/x-aiff',
        'aifc'  =>  'audio/x-aiff',
        'ram'   =>  'audio/x-pn-realaudio',
        'rm'    =>  'audio/x-pn-realaudio',
        'rpm'   =>  'audio/x-pn-realaudio-plugin',
        'ra'    =>  'audio/x-realaudio',
-       'rv'    =>  'video/vnd.rn-realvideo',
        'wav'   =>  'audio/x-wav',
        'bmp'   =>  'image/bmp',
        'gif'   =>  'image/gif',
        'jpeg'  =>  'image/jpeg',
-       'jpg'   =>  'image/jpeg',
        'jpe'   =>  'image/jpeg',
        'png'   =>  'image/png',
        'tiff'  =>  'image/tiff',
        'tif'   =>  'image/tiff',
        'css'   =>  'text/css',
        'html'  =>  'text/html',
        'htm'   =>  'text/html',
        'shtml' =>  'text/html',
-       'txt'   =>  'text/plain',
-       'text'  =>  'text/plain',
        'log'   =>  'text/plain',
        'rtx'   =>  'text/richtext',
        'rtf'   =>  'text/rtf',
        'xml'   =>  'text/xml',
        'xsl'   =>  'text/xml',
        'mpeg'  =>  'video/mpeg',
-       'mpg'   =>  'video/mpeg',
        'mpe'   =>  'video/mpeg',
!       'qt'    =>  'video/quicktime',
        'mov'   =>  'video/quicktime',
        'avi'   =>  'video/x-msvideo',
!       'movie' =>  'video/x-sgi-movie',
!       'doc'   =>  'application/msword',
!       'word'  =>  'application/msword',
!       'xl'    =>  'application/excel',
!       'eml'   =>  'message/rfc822'
      );
      return (!isset($mimes[strtolower($ext)])) ? 'application/octet-stream' : $mimes[strtolower($ext)];
    }
--- 2564,2613 ----
        'sit'   =>  'application/x-stuffit',
        'tar'   =>  'application/x-tar',
        'tgz'   =>  'application/x-tar',
        'xht'   =>  'application/xhtml+xml',
+       'xhtml' =>  'application/xhtml+xml',
        'zip'   =>  'application/zip',
        'mid'   =>  'audio/midi',
        'midi'  =>  'audio/midi',
        'mp2'   =>  'audio/mpeg',
        'mp3'   =>  'audio/mpeg',
+       'mpga'  =>  'audio/mpeg',
        'aif'   =>  'audio/x-aiff',
        'aifc'  =>  'audio/x-aiff',
+       'aiff'  =>  'audio/x-aiff',
        'ram'   =>  'audio/x-pn-realaudio',
        'rm'    =>  'audio/x-pn-realaudio',
        'rpm'   =>  'audio/x-pn-realaudio-plugin',
        'ra'    =>  'audio/x-realaudio',
        'wav'   =>  'audio/x-wav',
        'bmp'   =>  'image/bmp',
        'gif'   =>  'image/gif',
        'jpeg'  =>  'image/jpeg',
        'jpe'   =>  'image/jpeg',
+       'jpg'   =>  'image/jpeg',
        'png'   =>  'image/png',
        'tiff'  =>  'image/tiff',
        'tif'   =>  'image/tiff',
+       'eml'   =>  'message/rfc822',
        'css'   =>  'text/css',
        'html'  =>  'text/html',
        'htm'   =>  'text/html',
        'shtml' =>  'text/html',
        'log'   =>  'text/plain',
+       'text'  =>  'text/plain',
+       'txt'   =>  'text/plain',
        'rtx'   =>  'text/richtext',
        'rtf'   =>  'text/rtf',
        'xml'   =>  'text/xml',
        'xsl'   =>  'text/xml',
        'mpeg'  =>  'video/mpeg',
        'mpe'   =>  'video/mpeg',
!       'mpg'   =>  'video/mpeg',
        'mov'   =>  'video/quicktime',
+       'qt'    =>  'video/quicktime',
+       'rv'    =>  'video/vnd.rn-realvideo',
        'avi'   =>  'video/x-msvideo',
!       'movie' =>  'video/x-sgi-movie'
      );
      return (!isset($mimes[strtolower($ext)])) ? 'application/octet-stream' : $mimes[strtolower($ext)];
    }
***************
*** 2353,2358 ****
--- 2622,2629 ----
    * @param string $name Parameter Name
    * @param mixed $value Parameter Value
    * NOTE: will not work with arrays, there are no arrays to set/reset
+    * @throws phpmailerException
+    * @return bool
    * @todo Should this not be using __set() magic function?
    */
    public function set($name, $value = '') {
***************
*** 2378,2392 ****
     * @return string
     */
    public function SecureHeader($str) {
!     $str = str_replace("\r", '', $str);
!     $str = str_replace("\n", '', $str);
!     return trim($str);
    }
  
    /**
     * Set the private key file and password to sign the message.
     *
     * @access public
     * @param string $key_filename Parameter File Name
     * @param string $key_pass Password for private key
     */
--- 2649,2662 ----
     * @return string
     */
    public function SecureHeader($str) {
!     return trim(str_replace(array("\r", "\n"), '', $str));
    }
  
    /**
     * Set the private key file and password to sign the message.
     *
     * @access public
+    * @param $cert_filename
     * @param string $key_filename Parameter File Name
     * @param string $key_pass Password for private key
     */
***************
*** 2400,2410 ****
     * Set the private key file and password to sign the message.
     *
     * @access public
!    * @param string $key_filename Parameter File Name
!    * @param string $key_pass Password for private key
     */
    public function DKIM_QP($txt) {
-     $tmp = '';
      $line = '';
      for ($i = 0; $i < strlen($txt); $i++) {
        $ord = ord($txt[$i]);
--- 2670,2679 ----
     * Set the private key file and password to sign the message.
     *
     * @access public
!    * @param string $txt
!    * @return string
     */
    public function DKIM_QP($txt) {
      $line = '';
      for ($i = 0; $i < strlen($txt); $i++) {
        $ord = ord($txt[$i]);
***************
*** 2422,2427 ****
--- 2691,2697 ----
     *
     * @access public
     * @param string $s Header
+    * @return string
     */
    public function DKIM_Sign($s) {
      $privKeyStr = file_get_contents($this->DKIM_private);
***************
*** 2433,2438 ****
--- 2703,2709 ----
      if (openssl_sign($s, $signature, $privKey)) {
        return base64_encode($signature);
      }
+     return '';
    }
  
    /**
***************
*** 2440,2445 ****
--- 2711,2717 ----
     *
     * @access public
     * @param string $s Header
+    * @return string
     */
    public function DKIM_HeaderC($s) {
      $s = preg_replace("/\r\n\s+/", " ", $s);
***************
*** 2459,2464 ****
--- 2731,2737 ----
     *
     * @access public
     * @param string $body Message Body
+    * @return string
     */
    public function DKIM_BodyC($body) {
      if ($body == '') return "\r\n";
***************
*** 2479,2484 ****
--- 2752,2758 ----
     * @param string $headers_line Header lines
     * @param string $subject Subject
     * @param string $body Body
+    * @return string
     */
    public function DKIM_Add($headers_line, $subject, $body) {
      $DKIMsignatureType    = 'rsa-sha1'; // Signature & hash algorithms
***************
*** 2487,2492 ****
--- 2761,2768 ----
      $DKIMtime             = time() ; // Signature Timestamp = seconds since 00:00:00 - Jan 1, 1970 (UTC time zone)
      $subject_header       = "Subject: $subject";
      $headers              = explode($this->LE, $headers_line);
+ 	$from_header          = "";
+ 	$to_header            = "";
      foreach($headers as $header) {
        if (strpos($header, 'From:') === 0) {
          $from_header = $header;
***************
*** 2512,2529 ****
                  "\tb=";
      $toSign   = $this->DKIM_HeaderC($from_header . "\r\n" . $to_header . "\r\n" . $subject_header . "\r\n" . $dkimhdrs);
      $signed   = $this->DKIM_Sign($toSign);
!     return "X-PHPMAILER-DKIM: phpmailer.worxware.com\r\n".$dkimhdrs.$signed."\r\n";
    }
  
!   protected function doCallback($isSent, $to, $cc, $bcc, $subject, $body) {
!     if (!empty($this->action_function) && function_exists($this->action_function)) {
!       $params = array($isSent, $to, $cc, $bcc, $subject, $body);
        call_user_func_array($this->action_function, $params);
      }
    }
  }
  
  class phpmailerException extends Exception {
    public function errorMessage() {
      $errorMsg = '<strong>' . $this->getMessage() . "</strong><br />\n";
      return $errorMsg;
--- 2788,2823 ----
                  "\tb=";
      $toSign   = $this->DKIM_HeaderC($from_header . "\r\n" . $to_header . "\r\n" . $subject_header . "\r\n" . $dkimhdrs);
      $signed   = $this->DKIM_Sign($toSign);
!     return "X-PHPMAILER-DKIM: code.google.com/a/apache-extras.org/p/phpmailer/\r\n".$dkimhdrs.$signed."\r\n";
    }
  
!   /**
!    * Perform callback
!    * @param boolean $isSent
!    * @param string $to
!    * @param string $cc
!    * @param string $bcc
!    * @param string $subject
!    * @param string $body
!    * @param string $from
!    */
!   protected function doCallback($isSent, $to, $cc, $bcc, $subject, $body, $from=null) {
!     if (!empty($this->action_function) && is_callable($this->action_function)) {
!       $params = array($isSent, $to, $cc, $bcc, $subject, $body, $from);
        call_user_func_array($this->action_function, $params);
      }
    }
  }
  
+ /**
+  * Exception handler for PHPMailer
+  * @package PHPMailer
+  */
  class phpmailerException extends Exception {
+   /**
+    * Prettify error message output
+    * @return string
+    */
    public function errorMessage() {
      $errorMsg = '<strong>' . $this->getMessage() . "</strong><br />\n";
      return $errorMsg;
